Overview | Package | Class | Tree | Deprecated | Index | Help
| Openfire 3.7.1 Javadoc
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jivesoftware.openfire.clearspace
Class ClearspaceSaslServer

    java.lang.Object
      org.jivesoftware.openfire.clearspace.ClearspaceSaslServer

All Implemented Interfaces:
  SaslServer

    public class ClearspaceSaslServer

extends Object
implements SaslServer

Implements the CLEARSPACE server-side SASL mechanism.

Author:
  Armando Jagucki

Constructor Summary
`ClearspaceSaslServer()`

Method Summary
`void` | `dispose()` Disposes of any system resources or security-sensitive information the SaslServer might be using.
`byte[]` | `evaluateResponse(byte[] response)` Evaluates the response data and generates a challenge.
`String` | `getAuthorizationID()` Reports the authorization ID in effect for the client of this session.
`String` | `getMechanismName()` Returns the mechanism name of this SASL server.
`Object` | `getNegotiatedProperty(String propName)` Retrieves the negotiated property.
`boolean` | `isComplete()` Determines whether the authentication exchange has completed.
`byte[]` | `unwrap(byte[] incoming, int offset, int len)` Unwraps a byte array received from the client.
`byte[]` | `wrap(byte[] outgoing, int offset, int len)` Wraps a byte array to be sent to the client.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ClearspaceSaslServer

    public ClearspaceSaslServer()

Method Detail

### getMechanismName

    public String getMechanismName()

  Returns the mechanism name of this SASL server. (e.g. "CRAM-MD5", "GSSAPI").

  Specified by:
    `getMechanismName` in interface `SaslServer`
  Returns:
    A non-null string representing the mechanism name.

### evaluateResponse

    public byte[] evaluateResponse(byte[] response)
                            throws SaslException

  Evaluates the response data and generates a challenge.

  If a response is received from the client during the authentication process, this method is called to prepare an appropriate next challenge to submit to the client. The challenge is null if the authentication has succeeded and no more challenge data is to be sent to the client. It is non-null if the authentication must be continued by sending a challenge to the client, or if the authentication has succeeded but challenge data needs to be processed by the client. `isComplete()` should be called after each call to `evaluateResponse()`,to determine if any further response is needed from the client.

  Specified by:
    `evaluateResponse` in interface `SaslServer`
  Parameters:
    `response` - The non-null (but possibly empty) response sent by the client.
  Returns:
    The possibly null challenge to send to the client. It is null if the authentication has succeeded and there is no more challenge data to be sent to the client.
  Throws:
    `SaslException` - If an error occurred while processing the response or generating a challenge.

### isComplete

    public boolean isComplete()

  Determines whether the authentication exchange has completed. This method is typically called after each invocation of `evaluateResponse()` to determine whether the authentication has completed successfully or should be continued.

  Specified by:
    `isComplete` in interface `SaslServer`
  Returns:
    true if the authentication exchange has completed; false otherwise.

### getAuthorizationID

    public String getAuthorizationID()

  Reports the authorization ID in effect for the client of this session. This method can only be called if isComplete() returns true.

  Specified by:
    `getAuthorizationID` in interface `SaslServer`
  Returns:
    The authorization ID of the client.
  Throws:
    `IllegalStateException` - if this authentication session has not completed

### unwrap

    public byte[] unwrap(byte[] incoming,
                         int offset,
                         int len)
                  throws SaslException

  Unwraps a byte array received from the client. This method can be called only after the authentication exchange has completed (i.e., when `isComplete()` returns true) and only if the authentication exchange has negotiated integrity and/or privacy as the quality of protection; otherwise, an `IllegalStateException` is thrown.

  `incoming` is the contents of the SASL buffer as defined in RFC 2222 without the leading four octet field that represents the length. `offset` and `len` specify the portion of `incoming` to use.

  Specified by:
    `unwrap` in interface `SaslServer`
  Parameters:
    `incoming` - A non-null byte array containing the encoded bytes from the client.
    `offset` - The starting position at `incoming` of the bytes to use.
    `len` - The number of bytes from `incoming` to use.
  Returns:
    A non-null byte array containing the decoded bytes.
  Throws:
    `SaslException` - if `incoming` cannot be successfully unwrapped.
    `IllegalStateException` - if the authentication exchange has not completed, or if the negotiated quality of protection has neither integrity nor privacy

### wrap

    public byte[] wrap(byte[] outgoing,
                       int offset,
                       int len)
                throws SaslException

  Wraps a byte array to be sent to the client. This method can be called only after the authentication exchange has completed (i.e., when `isComplete()` returns true) and only if the authentication exchange has negotiated integrity and/or privacy as the quality of protection; otherwise, a `SaslException` is thrown.

  The result of this method will make up the contents of the SASL buffer as defined in RFC 2222 without the leading four octet field that represents the length. `offset` and `len` specify the portion of `outgoing` to use.

  Specified by:
    `wrap` in interface `SaslServer`
  Parameters:
    `outgoing` - A non-null byte array containing the bytes to encode.
    `offset` - The starting position at `outgoing` of the bytes to use.
    `len` - The number of bytes from `outgoing` to use.
  Returns:
    A non-null byte array containing the encoded bytes.
  Throws:
    `SaslException` - if `outgoing` cannot be successfully wrapped.
    `IllegalStateException` - if the authentication exchange has not completed, or if the negotiated quality of protection has neither integrity nor privacy.

### getNegotiatedProperty

    public Object getNegotiatedProperty(String propName)

  Retrieves the negotiated property. This method can be called only after the authentication exchange has completed (i.e., when `isComplete()` returns true); otherwise, an `IllegalStateException` is thrown.

  Specified by:
    `getNegotiatedProperty` in interface `SaslServer`
  Parameters:
    `propName` - the property
  Returns:
    The value of the negotiated property. If null, the property was not negotiated or is not applicable to this mechanism.
  Throws:
    `IllegalStateException` - if this authentication exchange has not completed

### dispose

    public void dispose()
                 throws SaslException

  Disposes of any system resources or security-sensitive information the SaslServer might be using. Invoking this method invalidates the SaslServer instance. This method is idempotent.

  Specified by:
    `dispose` in interface `SaslServer`
  Throws:
    `SaslException` - If a problem was encountered while disposing the resources.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Openfire 3.7.1 Javadoc
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2008 Jive Software.